program lcd;

uses crt;

type LCDChar = array [1..8] of byte;

const LPT       = $378;
      LCD_Data  = LPT;
      LCD_CTRL  = LPT+2;

var Dummy : LCDChar;

procedure LCD_WriteCTRL(data : byte);
begin
  port[LCD_CTRL]:=3;
  port[LCD_Data]:=data;
  port[LCD_CTRL]:=2;
  port[LCD_CTRL]:=3;
  port[LCD_CTRL]:=1;
  delay(10);
end;

procedure LCD_WriteDATA(data : byte);
begin
  port[LCD_CTRL]:=7;
  port[LCD_Data]:=data;
  port[LCD_CTRL]:=6;
  port[LCD_CTRL]:=7;
  port[LCD_CTRL]:=5;
  delay(1);
end;

procedure LCD_Clear;
begin
  LCD_WriteCTRL($1);
end;

procedure LCD_Home;
begin
  LCD_WriteCTRL($2);
end;

procedure LCD_WriteChar(data : char);
begin
  LCD_WriteDATA(ord(data));
end;

procedure LCD_Write(data : string);
var counter : integer;
begin
  for counter:=1 to length(data) do
    LCD_WriteChar(data[counter]);
end;

procedure LCD_InitDriver;
begin
  LCD_WriteCTRL($38);
  LCD_WriteCTRL($38);
  LCD_WriteCTRL($38);
  LCD_WriteCTRL($6);
  LCD_WriteCTRL($c);
end;

procedure LCD_Init;
begin
  LCD_InitDriver;
  LCD_Clear;
  LCD_Home;
end;

procedure LCD_Goto(x,y : byte);
var counter : integer;
begin
  case y of
   1: LCD_WriteCTRL($80+x-1);
   2: LCD_WriteCTRL($c0+x-1);
   3: LCD_WriteCTRL($94+x-1);
   4: LCD_WriteCTRL($d4+x-1);
   end;
end;


procedure LCD_WritePos(x,y : byte; data : string);
begin
  LCD_Goto(x,y);
  LCD_Write(data);
end;

procedure LCD_WriteRow(row : byte; data :string);
begin
  LCD_Goto(1,row);
  LCD_Write(data);
end;

procedure LCD_DefineChar(CharNo : byte;Data : LCDChar);
var counter:integer;
begin
  LCD_WriteCTRL($40 + (CharNo SHL 3));
  for counter:= 1 to 8 do
    LCD_WriteDATA(Data[Counter]);

end;

begin
  LCD_Init;
  LCD_Clear;
  LCD_WriteRow(1,'Madonna');
  LCD_WriteRow(2,'Ray of Light');
  LCD_WriteRow(3,'                PLAY');
  LCD_WriteRow(4,'             SHUFFLE');

  Dummy[1]:=$18;
  Dummy[2]:=$1c;
  Dummy[3]:=$1e;
  Dummy[4]:=$1f;
  Dummy[5]:=$1e;
  Dummy[6]:=$1c;
  Dummy[7]:=$18;
  Dummy[8]:=0;

  LCD_DefineChar(1,Dummy);
  LCD_Goto(16,3);
  LCD_WriteData(1);

  Dummy[1]:=$2;
  Dummy[2]:=$7;
  Dummy[3]:=$a;
  Dummy[4]:=$8;
  Dummy[5]:=$2;
  Dummy[6]:=$a;
  Dummy[7]:=$1c;
  Dummy[8]:=8;

  LCD_DefineChar(2,Dummy);
  LCD_Goto(13,4);
  LCD_WriteData(2);


end.
